package com.agiledeveloper;

public class Test
{
    public static <T extends Comparable> T max(T obj1, T obj2)
    {
        if (obj1.compareTo(obj2) > 0)
        {
            return obj1;
        }
        return obj2;
    }

    public static void main(String[] args)
    {
        Integer i1 = new Integer(1);
        Integer i2 = new Integer(2);

        System.out.println(max(i1, i2));
        System.out.println(max(i2, i1));

        Double d1 = new Double(2.2);
        Double d2 = new Double(3.2);

        System.out.println(max(d1, d2));

        //System.out.println(max(d1, i1));
        // Compilation error, because the common type Object
        // does not implement Comparable
    }
}
